Selector that filters files based on their size.

It provides support for gathering the parameters together as well as for assigning an error message and throwing a build exception if an error is detected.

author | Hans Lellelid <hans@xmpl.org> (Phing)
author | Bruce Atherton <bruce@callenish.com> (Ant)
package | phing.types.selectors
version | $Id$

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()
inherited_from | \BaseSelector::circularReference()
inherited_from | \BaseExtendSelector::circularReference()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()
inherited_from | \BaseSelector::dieOnCircularReference()
inherited_from | \BaseExtendSelector::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()
inherited_from | \BaseSelector::getCheckedRef()
inherited_from | \BaseExtendSelector::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()
inherited_from | \BaseSelector::getDescription()
inherited_from | \BaseExtendSelector::getDescription()

## Returns any error messages that have been set.

    getError() : \the

Inherited

inherited_from | \BaseSelector::getError()
inherited_from | \BaseExtendSelector::getError()

### Returns

`\the`error condition

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()
inherited_from | \BaseSelector::getProject()
inherited_from | \BaseExtendSelector::getProject()

### Returns

`\Project`Reference to current porject object

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()
inherited_from | \BaseSelector::isReference()
inherited_from | \BaseExtendSelector::isReference()

## The heart of the matter.

    isSelected(\PhingFile $basedir, \filename $filename, \PhingFile $file) : \whether

This is where the selector gets to decide on the inclusion of a file in a particular fileset.

### Parameters

#### $basedir

`\basedir`

A PhingFile object for the base directory

#### $filename

`\filename`

The name of the file to check

#### $file

`\file`

A PhingFile object for this filename

### Exceptions

`\BuildException` | if the selector was not configured correctly

### Returns

`\whether`the file should be selected or not

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()
inherited_from | \BaseSelector::log()
inherited_from | \BaseExtendSelector::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()
inherited_from | \BaseSelector::noChildrenAllowed()
inherited_from | \BaseExtendSelector::noChildrenAllowed()

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

Inherited

inherited_from | \DataType::parsingComplete()
inherited_from | \BaseSelector::parsingComplete()
inherited_from | \BaseExtendSelector::parsingComplete()

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()
inherited_from | \BaseSelector::setDescription()
inherited_from | \BaseExtendSelector::setDescription()

### Parameters

#### $desc

## Allows all selectors to indicate a setup error.

    setError(\msg $msg)

Inherited

Note that only the first error message is recorded.

inherited_from | \BaseSelector::setError()
inherited_from | \BaseExtendSelector::setError()

### Parameters

#### $msg

`\msg`

The error message any BuildException should throw.

## When using this as a custom selector, this method will be called.

    setParameters(\parameters $parameters)

It translates each parameter into the appropriate setXXX() call.

### Parameters

#### $parameters

`\parameters`

the complete set of parameters for this selector

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()
inherited_from | \BaseSelector::setProject()
inherited_from | \BaseExtendSelector::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

Inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

inherited_from | \DataType::setRefid()
inherited_from | \BaseSelector::setRefid()
inherited_from | \BaseExtendSelector::setRefid()

### Parameters

#### $r

`\Reference`

## Sets the units to use for the comparison.

    setUnits($units) : void

This is a little complicated because common usage has created standards that play havoc with capitalization rules. Thus, some people will use "K" for indicating 1000's, when the SI standard calls for "k". Others have tried to introduce "K" as a multiple of 1024, but that falls down when you reach "M", since "m" is already defined as 0.001.

<

p> To get around this complexity, a number of standards bodies have proposed the 2^10 standard, and at least one has adopted it. But we are still left with a populace that isn't clear on how capitalization should work.

<

p> We therefore ignore capitalization as much as possible. Completely mixed case is not possible, but all upper and lower forms are accepted for all long and short forms. Since we have no need to work with the 0.001 case, this practice works here.

<

p> This function translates all the long and short forms that a unit prefix can occur in and translates them into a single multiplier.

### Parameters

#### $units

The units to compare the size to.

## A size selector needs to know what size to base its selecting on.

    setValue(\size $size)

This will be further modified by the multiplier to get an actual size limit.

### Parameters

#### $size

`\size`

the size to select against expressed in units

## This specifies when the file should be selected, whether it be when the file matches a particular size, when it is smaller, or whether it is larger.

    setWhen(\cmp $cmp)

### Parameters

#### $cmp

`\cmp`

The comparison to perform, an EnumeratedAttribute

## toString()

    toString()

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()
inherited_from | \BaseSelector::tooManyAttributes()
inherited_from | \BaseExtendSelector::tooManyAttributes()

## Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

    validate()

Inherited

inherited_from | \BaseSelector::validate()
inherited_from | \BaseExtendSelector::validate()

## <p>Checks to make sure all settings are kosher.

    verifySettings()

In this case, it means that the size attribute has been set (to a positive value), that the multiplier has a valid setting, and that the size limit is valid. Since the latter is a calculated value, this can only fail due to a programming error.

If a problem is detected, the setError() method is called.

## Allows access to the parameters gathered and set within the &lt;custom&gt; tag.

    getParameters() : \the

Inherited

inherited_from | \BaseExtendSelector::getParameters()

### Returns

`\the`set of parameters defined for this selector

### Properties

##

    $description

Inherited

inherited_from | \DataType::$$description
inherited_from | \BaseSelector::$$description
inherited_from | \BaseExtendSelector::$$description

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref
inherited_from | \BaseSelector::$$ref
inherited_from | \BaseExtendSelector::$$ref

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked
inherited_from | \BaseSelector::$$checked
inherited_from | \BaseExtendSelector::$$checked

##

    $parameters

Inherited

inherited_from | \BaseExtendSelector::$$parameters

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project
inherited_from | \BaseSelector::$$project
inherited_from | \BaseExtendSelector::$$project

##

    $byteUnits

##

    $cmp

##

    $errmsg

Inherited

inherited_from | \BaseSelector::$$errmsg
inherited_from | \BaseExtendSelector::$$errmsg

##

    $multiplier

##

    $size

##

    $sizeComparisons

##

    $sizelimit

### Constants

## SIZE_KEY

    SIZE_KEY

## UNITS_KEY

    UNITS_KEY

## WHEN_KEY

    WHEN_KEY